#ifndef _COMPAT_HVM_DM_OP_H
#define _COMPAT_HVM_DM_OP_H
#include <xen/compat.h>
#include <public/hvm/dm_op.h>
#include "../xen.h"
#include "../event_channel.h"
typedef uint16_t ioservid_compat_t;
struct compat_dm_op_create_ioreq_server {

    uint8_t handle_bufioreq;
    uint8_t pad[3];

    ioservid_compat_t id;
};
typedef struct xen_dm_op_create_ioreq_server __attribute__((__aligned__(__alignof( struct compat_dm_op_create_ioreq_server)))) compat_dm_op_create_ioreq_server_t;
struct compat_dm_op_get_ioreq_server_info {

    ioservid_compat_t id;

    uint16_t flags;

    evtchn_port_compat_t bufioreq_port;

    uint64_compat_t ioreq_gfn;

    uint64_compat_t bufioreq_gfn;
};
typedef struct xen_dm_op_get_ioreq_server_info __attribute__((__aligned__(__alignof( struct compat_dm_op_get_ioreq_server_info)))) compat_dm_op_get_ioreq_server_info_t;
struct compat_dm_op_ioreq_server_range {

    ioservid_compat_t id;
    uint16_t pad;

    uint32_t type;

    uint64_compat_t start, end;
};
typedef struct xen_dm_op_ioreq_server_range __attribute__((__aligned__(__alignof( struct compat_dm_op_ioreq_server_range)))) compat_dm_op_ioreq_server_range_t;
struct compat_dm_op_set_ioreq_server_state {

    ioservid_compat_t id;

    uint8_t enabled;
    uint8_t pad;
};
typedef struct xen_dm_op_set_ioreq_server_state __attribute__((__aligned__(__alignof( struct compat_dm_op_set_ioreq_server_state)))) compat_dm_op_set_ioreq_server_state_t;
struct compat_dm_op_destroy_ioreq_server {

    ioservid_compat_t id;
    uint16_t pad;
};
typedef struct xen_dm_op_destroy_ioreq_server __attribute__((__aligned__(__alignof( struct compat_dm_op_destroy_ioreq_server)))) compat_dm_op_destroy_ioreq_server_t;
struct compat_dm_op_track_dirty_vram {

    uint32_t nr;
    uint32_t pad;

    uint64_compat_t first_pfn;
};
typedef struct xen_dm_op_track_dirty_vram __attribute__((__aligned__(__alignof( struct compat_dm_op_track_dirty_vram)))) compat_dm_op_track_dirty_vram_t;

struct compat_dm_op_set_pci_intx_level {

    uint16_t domain;
    uint8_t bus, device, intx;

    uint8_t level;
};
typedef struct xen_dm_op_set_pci_intx_level __attribute__((__aligned__(__alignof( struct compat_dm_op_set_pci_intx_level)))) compat_dm_op_set_pci_intx_level_t;

struct compat_dm_op_set_isa_irq_level {

    uint8_t isa_irq;

    uint8_t level;
};
typedef struct xen_dm_op_set_isa_irq_level __attribute__((__aligned__(__alignof( struct compat_dm_op_set_isa_irq_level)))) compat_dm_op_set_isa_irq_level_t;

struct compat_dm_op_set_pci_link_route {

    uint8_t link;

    uint8_t isa_irq;
};
typedef struct xen_dm_op_set_pci_link_route __attribute__((__aligned__(__alignof( struct compat_dm_op_set_pci_link_route)))) compat_dm_op_set_pci_link_route_t;
struct compat_dm_op_modified_memory {

    uint32_t nr_extents;

    uint32_t opaque;
};
typedef struct xen_dm_op_modified_memory __attribute__((__aligned__(__alignof( struct compat_dm_op_modified_memory)))) compat_dm_op_modified_memory_t;

struct compat_dm_op_modified_memory_extent {

    uint32_t nr;
    uint32_t pad;

    uint64_compat_t first_pfn;
};
struct compat_dm_op_set_mem_type {

    uint32_t nr;

    uint16_t mem_type;
    uint16_t pad;

    uint64_compat_t first_pfn;
};
typedef struct xen_dm_op_set_mem_type __attribute__((__aligned__(__alignof( struct compat_dm_op_set_mem_type)))) compat_dm_op_set_mem_type_t;
struct compat_dm_op_inject_event {

    uint32_t vcpuid;

    uint8_t vector;

    uint8_t type;
    uint8_t insn_len;
    uint8_t pad0;

    uint32_t error_code;
    uint32_t pad1;

    uint64_compat_t cr2;
};
typedef struct xen_dm_op_inject_event __attribute__((__aligned__(__alignof( struct compat_dm_op_inject_event)))) compat_dm_op_inject_event_t;

struct compat_dm_op_inject_msi {

    uint32_t data;
    uint32_t pad;

    uint64_compat_t addr;
};
typedef struct xen_dm_op_inject_msi __attribute__((__aligned__(__alignof( struct compat_dm_op_inject_msi)))) compat_dm_op_inject_msi_t;
struct compat_dm_op_map_mem_type_to_ioreq_server {
    ioservid_compat_t id;
    uint16_t type;
    uint32_t flags;

    uint64_compat_t opaque;

};
typedef struct xen_dm_op_map_mem_type_to_ioreq_server __attribute__((__aligned__(__alignof( struct compat_dm_op_map_mem_type_to_ioreq_server)))) compat_dm_op_map_mem_type_to_ioreq_server_t;

struct compat_dm_op_remote_shutdown {
    uint32_t reason;

};
typedef struct xen_dm_op_remote_shutdown __attribute__((__aligned__(__alignof( struct compat_dm_op_remote_shutdown)))) compat_dm_op_remote_shutdown_t;
struct compat_dm_op_relocate_memory {

    uint32_t size;
    uint32_t pad;

    uint64_compat_t src_gfn;

    uint64_compat_t dst_gfn;
};
typedef struct xen_dm_op_relocate_memory __attribute__((__aligned__(__alignof( struct compat_dm_op_relocate_memory)))) compat_dm_op_relocate_memory_t;

struct compat_dm_op_pin_memory_cacheattr {
    uint64_compat_t start;
    uint64_compat_t end;
    uint32_t type;
    uint32_t pad;
};
typedef struct xen_dm_op_pin_memory_cacheattr __attribute__((__aligned__(__alignof( struct compat_dm_op_pin_memory_cacheattr)))) compat_dm_op_pin_memory_cacheattr_t;
struct compat_dm_op_set_irq_level {
    uint32_t irq;

    uint8_t level;
    uint8_t pad[3];
};
typedef struct compat_dm_op_set_irq_level compat_dm_op_set_irq_level_t;
struct compat_dm_op_nr_vcpus {
    uint32_t vcpus;
};
typedef struct xen_dm_op_nr_vcpus __attribute__((__aligned__(__alignof( struct compat_dm_op_nr_vcpus)))) compat_dm_op_nr_vcpus_t;

struct compat_dm_op {
    uint32_t op;
    uint32_t pad;
    union {
        compat_dm_op_create_ioreq_server_t create_ioreq_server;
        compat_dm_op_get_ioreq_server_info_t get_ioreq_server_info;
        compat_dm_op_ioreq_server_range_t map_io_range_to_ioreq_server;
        compat_dm_op_ioreq_server_range_t unmap_io_range_from_ioreq_server;
        compat_dm_op_set_ioreq_server_state_t set_ioreq_server_state;
        compat_dm_op_destroy_ioreq_server_t destroy_ioreq_server;
        compat_dm_op_track_dirty_vram_t track_dirty_vram;
        compat_dm_op_set_pci_intx_level_t set_pci_intx_level;
        compat_dm_op_set_isa_irq_level_t set_isa_irq_level;
        compat_dm_op_set_irq_level_t set_irq_level;
        compat_dm_op_set_pci_link_route_t set_pci_link_route;
        compat_dm_op_modified_memory_t modified_memory;
        compat_dm_op_set_mem_type_t set_mem_type;
        compat_dm_op_inject_event_t inject_event;
        compat_dm_op_inject_msi_t inject_msi;
        compat_dm_op_map_mem_type_to_ioreq_server_t map_mem_type_to_ioreq_server;
        compat_dm_op_remote_shutdown_t remote_shutdown;
        compat_dm_op_relocate_memory_t relocate_memory;
        compat_dm_op_pin_memory_cacheattr_t pin_memory_cacheattr;
        compat_dm_op_nr_vcpus_t nr_vcpus;
    } u;
};

struct compat_dm_op_buf {
    COMPAT_HANDLE(void) h;
    compat_ulong_t size;
};
typedef struct compat_dm_op_buf compat_dm_op_buf_t;
DEFINE_COMPAT_HANDLE(compat_dm_op_buf_t);
#endif /* _COMPAT_HVM_DM_OP_H */
